--[[
	This is very much a homage to RangeHelp an addon that had this
	functionality and much more, but i realized that i didnt need
	anything other than the range button so i remade it in the
	image of ace2 with some extra spiffes.
	
	Original RangeHelp can be found at http://www.curse-gaming.com/en/wow/addons-1549-1-rangehelp.html
--]]

Nudge = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0")
local L = AceLibrary("AceLocale-2.2"):new("Nudge")

L:RegisterTranslations("enUS", function()
	return {
		["Auto Shot"] = true,
		["Wing Clip"] = true,
		["Melee"] = true,
		["In Range"] = true,
		["Dead Zone"] = true,
		["Out of Range"] = true,
	}
end)

L:RegisterTranslations("koKR", function()
	return {
		["Auto Shot"] = "자동 사격",
		["Wing Clip"] = "날개 절단",
		["Melee"] = "근접",
		["In Range"] = "원거리",
		["Dead Zone"] = "위험 존",
		["Out of Range"] = "거리 벗어남",
	}
end)

-- German translation comming from Lewelyn @ MannorothEU, much appreciated
L:RegisterTranslations("deDE", function()
	return {
		["Auto Shot"] = "Automatischer Schuss",
		["Wing Clip"] = "Zurechtstutzen",
		["Melee"] = "Nahkampf",
		["In Range"] = "Fernkampf",
		["Dead Zone"] = "Tote Zone",
		["Out of Range"] = "Ausser Reichweite",
	}
end)

-- French translation comming from Elisios, tackar
L:RegisterTranslations("frFR", function()
	return {
		["Auto Shot"] = "Tir automatique",
		["Wing Clip"] = "Coupure d'ailes",
		["Melee"] = "M\195\169lee",
		["In Range"] = "A port\195\169e",
		["Dead Zone"] = "Zone morte",
		["Out of Range"] = "Hors de port\195\169e",
	}
end)

L:RegisterTranslations("esES", function()
	return {
		["Auto Shot"] = "Disparo automático",
		["Wing Clip"] = "Cortar alas",
		["Melee"] = "Cuerpo a cuerpo",
		["In Range"] = "Dentro del Alcance",
		["Dead Zone"] = "Zona Muerta",
		["Out of Range"] = "Fuera de Alcance",
	}
end)

Nudge.defaults = {
	width		= 135,
	height		= 35,
	textSize	= 12,
	pos			= {},
	locked		= true,
	text		= true,
	colors		= {
		melee = { r=0, g=1, b=0, a=0.7 },
		range = { r=0, g=0, b=1, a=0.7 },
		deadzone = { r=1, g=0.5, b=0, a=0.7 },
		oorange = { r=1, g=0, b=0, a=0.7 }
	}
}

Nudge.options = {
		type = "group",
		args = {
			lock = {
				name = "lock",
				type = "toggle",
				desc = "Lock/Unlock the button.",
				get = function() return Nudge.db.profile.locked end,
				set = function( v ) Nudge.db.profile.locked = v end,
				map = {[false] = "Unlocked", [true] = "Locked"},
				guiNameIsMap = true,
			},
			width = {
				name = "width", type = 'range', min = 10, max = 5000, step = 1,
				desc = "Set the width of the button.",
				get = function() return Nudge.db.profile.width end,
				set = function( v )
					Nudge.db.profile.width = v
					Nudge:Layout()
				end
			},
			height = {
				name = "height", type = 'range', min = 5, max = 50, step = 1,
				desc = "Set the height of the button.",
				get = function() return Nudge.db.profile.height end,
				set = function( v )
					Nudge.db.profile.height = v
					Nudge:Layout()
				end
			},
			font = {
				name = "font", type = 'group',
				desc = "Set the font size.",
				args = {
					text = {
						name = "text", type = 'range', min = 6, max = 32, step = 1,
						desc = "Set the font size on the button.",
						get = function() return Nudge.db.profile.textSize end,
						set = function( v )
							Nudge.db.profile.textSize = v
							Nudge:Layout()
						end
					}
				}
			},
			text = {
				name = "text", type = 'toggle',
				desc = "Toggle displaying text on the button.",
				get = function() return Nudge.db.profile.text end,
				set = function( v )
					Nudge.db.profile.text = v
					Nudge.master.Range:SetText("")
				end,
				map = {[false] = "Off", [true] = "On"},
				guiNameIsMap = true,
			},
			color = {
				name = "color", type = 'group', order = 4,
				desc = "Set the color of the different button states.",
				args = {
					range = {
						name = "range", type = 'color',
						desc = "Set the color of the in range state.",
						get = function()
							local v = Nudge.db.profile.colors.range
							return v.r, v.g, v.b, v.a
						end,
						set = function(r,g,b,a) 
							Nudge.db.profile.colors.range = {r=r,g=g,b=b,a=a}
						end
					},
					oorange = {
						name = "oorange", type = 'color',
						desc = "Set the color of the out of range state.",
						get = function()
							local v = Nudge.db.profile.colors.oorange
							return v.r, v.g, v.b, v.a
						end,
						set = function(r,g,b,a) 
							Nudge.db.profile.colors.oorange = {r=r,g=g,b=b,a=a} 
						end
					},
					melee = {
						name = "melee", type = 'color',
						desc = "Set the color of the melee state.",
						get = function()
							local v = Nudge.db.profile.colors.melee
							return v.r, v.g, v.b, v.a
						end,
						set = function(r,g,b,a) 
							Nudge.db.profile.colors.melee = {r=r,g=g,b=b,a=a} 
						end
					},
					deadzone = {
						name = "deadzone", type = 'color',
						desc = "Set the color of the deadzone state.",
						get = function()
							local v = Nudge.db.profile.colors.deadzone
							return v.r, v.g, v.b, v.a
						end,
						set = function(r,g,b,a) 
							Nudge.db.profile.colors.deadzone = {r=r,g=g,b=b,a=a} 
						end
					}
				}
			}
		}
	}

Nudge:RegisterDB("NudgeDB")
Nudge:RegisterDefaults('profile', Nudge.defaults)
Nudge:RegisterChatCommand( {"/nudge"}, Nudge.options )

function Nudge:OnEnable()
	self:RegisterEvent("UNIT_FACTION", "TargetChanged")
	self:RegisterEvent("PLAYER_TARGET_CHANGED", "TargetChanged")
	self:CreateFrameWork()
end

function Nudge:SavePosition()
	local x, y = self.master:GetLeft(), self.master:GetTop()
	local s = self.master:GetEffectiveScale()
	
	self.db.profile.pos.x = x * s
	self.db.profile.pos.y = y * s
end

function Nudge:SetPosition()
	if self.db.profile.pos.x then
		local x = self.db.profile.pos.x
		local y = self.db.profile.pos.y

		local s = self.master:GetEffectiveScale()

		self.master:ClearAllPoints()
		self.master:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x / s, y / s)
	else
		self.master:ClearAllPoints()
		self.master:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	end
end

function Nudge:CreateFrameWork()	
	self.master = CreateFrame("Frame", "NudgeFrame", UIParent)
	self.master:Hide()
	
	self.master:SetMovable(true)
	self.master:EnableMouse(true)
	self.master:RegisterForDrag("LeftButton")
	self.master:SetScript("OnDragStart", function() if not self.db.profile.locked then self["master"]:StartMoving() end end)
	self.master:SetScript("OnDragStop", function() self["master"]:StopMovingOrSizing() self:SavePosition() end)
		
	self.master.Range = self.master:CreateFontString(nil, "OVERLAY")
	
	self:Layout()
end

function Nudge:Layout()
	local db = self.db.profile
	
	self.master:SetWidth( db.width )
	self.master:SetHeight( db.height )

	self.master:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 8,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
		edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
	})
	
	self.master:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b)
	self.master:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
	
	local gameFont, _, _ = GameFontHighlightSmall:GetFont()
	self.master.Range:SetJustifyH("CENTER")
	self.master.Range:SetFont( gameFont, db.textSize )
	self.master.Range:ClearAllPoints()
	self.master.Range:SetPoint("CENTER", self.master, "CENTER",0,0)
	self.master.Range:SetTextColor( 1,1,1 )
	
	self:SetPosition()
end

function Nudge:TargetChanged()
	if(UnitExists("target") and (not UnitIsDead("target")) and UnitCanAttack("player", "target")) then
		self.index = nil
		self:ScheduleRepeatingEvent("Nudge", self.OnUpdate, 0.1, self)
		self.master:Show()
	else
		self:CancelScheduledEvent("Nudge")
		self.master:Hide()
	end
end

function Nudge:OnUpdate()
	local text
	if IsSpellInRange(L["Wing Clip"]) == 1 then
		if Nudge.index ~= "melee" then
			text = L["Melee"]
			Nudge.index = "melee"
		else return end
	elseif IsSpellInRange(L["Auto Shot"]) == 1 then
		if Nudge.index ~= "range" then
			text = L["In Range"]
			Nudge.index = "range"
		else return end
	elseif CheckInteractDistance("target", 4) then
		if Nudge.index ~= "deadzone" then
			text = L["Dead Zone"]
			Nudge.index = "deadzone"
		else return end
	else
		if Nudge.index ~= "oorange" then
			text = L["Out of Range"]
			Nudge.index = "oorange"
		else return end
	end

	local db = Nudge.db.profile
	local color = db.colors[Nudge.index]
	
	Nudge.master:SetBackdropColor( 
		color.r,
		color.g,
		color.b,
		color.a
	)
		
	Nudge.master:SetBackdropBorderColor( 
		color.r,
		color.g,
		color.b,
		color.a
	)

	if db.text then
		Nudge.master.Range:SetText( text )
	end
end